/* 
 * File:   Svm.cpp
 * Author: gb
 * 
 * Created on 2 de Fevereiro de 2016, 21:40
 */

#include "Svm.h"

using namespace std;

Svm::Svm(int tipo, int kernel) {
    svm = SVM::create();
    // inicializa parametros
    svm->setType(tipo);
    svm->setKernel(kernel);
    
    this->matResults = Mat(0,0,CV_32SC1);
}

Svm::Svm(const Svm& orig) {
}

Svm::~Svm() {
}

void Svm::loadTrainAndAdjust(Mat matTrainFeatures, Mat matTrainLabels) {
    //associa treinamento com amostra criada
    //informa base em linhas ROW_SAMPLE (poderia ser colunas)
    trainingData=TrainData::create(matTrainFeatures,ROW_SAMPLE,matTrainLabels);
    
    
    //treina svm
    svm->trainAuto(trainingData);
    this->c = svm->getC();
    this->gamma = svm->getGamma();
}

void Svm::loadAndTrain(Mat matTrainFeatures, Mat matTrainLabels, 
                 double C, double gamma) {
    //associa treinamento com amostra criada
    //informa base em linhas ROW_SAMPLE (poderia ser colunas)
    trainingData=TrainData::create(matTrainFeatures,ROW_SAMPLE,matTrainLabels);
    
    svm->setC(C);
    svm->setGamma(gamma);
    
    svm->train(trainingData);
}

void Svm::predict(Mat matTestFeatures) {
    //faz o teste!
    svm->predict(matTestFeatures,matResults);
}


void Svm::checkResults(Mat matTestLabels, int numClasses) {
    float correto[numClasses], sum=0;
    float qtd[numClasses], all=0;

    for (int i=0; i<numClasses; i++) correto[i] = qtd[i] = 0;

    for (int i=0; i<matTestLabels.cols; i++) {
        if (matResults.at<float>(i,0) == matTestLabels.at<int>(0,i)) {
            correto[matTestLabels.at<int>(0,i)] +=1;
            sum +=1;
        }

        qtd[matTestLabels.at<int>(0,i)] +=1;
        all +=1;

    }
    cout << "Acurácia Geral: " << sum /all << endl;
        
    cout << "Acurácia por digito: " << endl;
    for (int i=0; i<numClasses; i++)
        cout << "(" << i << "): " << correto[i]/qtd[i] << endl;
}
