/* 
 * File:   Svm.h
 * Author: gb
 *
 * Created on 2 de Fevereiro de 2016, 21:40
 */

#ifndef SVM_H
#define	SVM_H
#include <opencv2/opencv.hpp>
#include <opencv2/ml.hpp>


using namespace cv;
using namespace cv::ml;

class Svm {
public:
    Svm(int tipo = SVM::C_SVC, int kernel=SVM::RBF);
    Svm(const Svm& orig);
    virtual ~Svm();
    
    void loadTrainAndAdjust(Mat matTrainFeatures, Mat matTrainLabels);
    
    
    void loadAndTrain(Mat matTrainFeatures, Mat matTrainLabels, 
                 double C = 1.0, double gamma=0.1);
    void predict(Mat matTestFeatures);
    
    void checkResults(Mat matTestLabels, int numClasses);
    
    //armazena os resultados
    //0,0 diz que será alocada pela quantidade de testes que existir
    Mat matResults;

    //parametros usados
    double c;
    double gamma;
    
private:
    //cria uma amostra de treinamento
    Ptr<TrainData> trainingData;
    
    //instancia SVM
    Ptr<SVM> svm;

};

#endif	/* SVM_H */

